package dp.composite.solution1;

import java.util.*;

public class ReportV2 {
	private static int nr = 0;
	public static int findItems( ManufacturingItem items[], String factory ) {
		System.out.println("Items manufactured in " + factory + ":");
		System.out.println("Nr.\tID\tName");
		System.out.println("----------------------------------");
		for( ManufacturingItem item : items ) {
			if( item==null )				continue;
			nr = showItem(item, factory);
			Iterator<ManufacturingItem> subItems = item.getParts();
			if( subItems==null )				continue;
			while( subItems.hasNext() ) {
				ManufacturingItem part = subItems.next();
				nr = showItem(part, factory);
			}
		}
		if( nr == 0 )
			System.out.println("No such item found.");
		return nr;
	}
	public static int showItem( ManufacturingItem item, String factory ) {
		if( item.getFactory().compareToIgnoreCase(factory) == 0 ) {
			nr++;
			System.out.println( nr + ".\t" + item.getMachineID() + 
					"\t" + item.getName() );
			return nr;
		}
		return nr;
		
	}
}
